﻿'
' 名称      ：rpls Viewer
' 概要      ：BDAVのプレイリストを表示する
' バージョン：1.11
' 作成日    ：2014/06/28
' 変更点    ：バージョン 1.11
'           ： GRの『ゝ』『ゞ』『ー』『。』『「』『」』『、』『・』が正しくデコードされない不具合を修正
'           ：
'           ：バージョン 1.10
'           ： セルを選択していない（編集している）場合でも選択テキストをクリップボードにコピーできるように変更
'           ： 「ヘッダ付きで出力」オプションを追加
'           ： コンテキストメニューを追加
'           ： CSV保存時に読み込み直後の内容ではなく、画面の表示内容を保存するように変更
'           ： 対応文字を追加、文字符号処理を修正
'           ： ARIB外字の「[」「]」が「(」「)」になっていた不具合を修正
'
' (C) 皆木 慎吾 2013
'
Public Class frmMain

    ' フォーム読込み時の処理
    Private Sub frmMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' 列幅を設定
        DataGridView1.Columns("numberColumn").Width = 46
        DataGridView1.Columns("recordDateColumn").Width = 111
        DataGridView1.Columns("durationColumn").Width = 78
        DataGridView1.Columns("channelColumn").Width = 46
        DataGridView1.Columns("makerIDColumn").Width = 67
        DataGridView1.Columns("makerModelCodeColumn").Width = 54

        ' メニュー・ツールバーの使用可否を設定
        上書き保存SToolStripMenuItem.Enabled = False
        上書き保存SToolStripButton.Enabled = False
        名前を付けて保存AToolStripMenuItem.Enabled = False
        コピーCToolStripMenuItem.Enabled = False
        コピーCToolStripButton.Enabled = False

        ' ステータスバーのテキストを設定
        tsslMain.Text = version_text

        ' 起動パラメータがあった場合、第1パラメータを使用する
        Dim cla() As String
        cla = System.Environment.GetCommandLineArgs()
        If Not IsNothing(cla) AndAlso cla.Length > 1 Then
            OpenFiles(cla(1))
        End If
    End Sub

    ' ドラッグされたときの処理
    Private Sub DataGridView1_DragEnter(sender As Object, e As DragEventArgs) Handles DataGridView1.DragEnter
        ' ドラッグされたのがファイルかどうかの判定
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    ' ドロップされたときの処理
    Private Sub DataGridView1_DragDrop(sender As Object, e As DragEventArgs) Handles DataGridView1.DragDrop
        Dim fileName As String() = CType(e.Data.GetData(DataFormats.FileDrop, False), String())
        OpenFiles(fileName(0))
    End Sub

    ' メニュー・ツールバーのイベントハンドラ

    Private Sub 新規作成NToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 新規作成NToolStripMenuItem.Click
        tbDiskName.Text = ""
        DataGridView1.Rows.Clear()
        上書き保存SToolStripMenuItem.Enabled = False
        上書き保存SToolStripButton.Enabled = False
        名前を付けて保存AToolStripMenuItem.Enabled = False
        コピーCToolStripMenuItem.Enabled = False
        コピーCToolStripButton.Enabled = False
        tsslMain.Text = version_text
    End Sub

    Private Sub 新規作成NToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles 新規作成NToolStripMenuItem1.Click
        新規作成NToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub 新規作成NToolStripButton_Click(sender As Object, e As EventArgs) Handles 新規作成NToolStripButton.Click
        新規作成NToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub 開くOToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 開くOToolStripMenuItem.Click
        Dim targetPath As String = ""
        If BrowseFolder(targetPath) = DialogResult.OK Then
            OpenFiles(targetPath)
        End If
    End Sub

    Private Sub 開くOToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles 開くOToolStripMenuItem1.Click
        開くOToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub 開くOToolStripButton_Click(sender As Object, e As EventArgs) Handles 開くOToolStripButton.Click
        開くOToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub 上書き保存SToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 上書き保存SToolStripMenuItem.Click
        If saveFileName <> "" Then
            SaveCSVFile(saveFileName)
        Else
            名前を付けて保存AToolStripMenuItem_Click(sender, e)
        End If
    End Sub

    Private Sub 上書き保存SToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles 上書き保存SToolStripMenuItem1.Click
        上書き保存SToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub 上書き保存SToolStripButton_Click(sender As Object, e As EventArgs) Handles 上書き保存SToolStripButton.Click
        上書き保存SToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub 名前を付けて保存AToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 名前を付けて保存AToolStripMenuItem.Click
        Dim dr As DialogResult
        dr = SaveFileDialog1.ShowDialog
        If dr = Windows.Forms.DialogResult.OK Then
            saveFileName = SaveFileDialog1.FileName
            SaveCSVFile(saveFileName)
        End If
    End Sub

    Private Sub 名前を付けて保存AToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles 名前を付けて保存AToolStripMenuItem1.Click
        名前を付けて保存AToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub 終了XToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 終了XToolStripMenuItem.Click
        End
    End Sub

    Private Sub コピーCToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles コピーCToolStripMenuItem.Click
        Dim cc As DataObject
        Dim tb As TextBox

        If withHeader Then
            ' ヘッダ付きでコピー
            DataGridView1.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableAlwaysIncludeHeaderText
        Else
            ' ヘッダなしでコピー
            DataGridView1.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText
        End If

        cc = DataGridView1.GetClipboardContent()
        If Not IsNothing(cc) Then
            ' セルが選択されている場合
            Clipboard.SetDataObject(cc)
            tsslMain.Text = "クリップボードにコピーしました。"
        Else
            ' セルが選択されていない場合
            '  編集されているセルの選択テキストをコピー
            tb = CType(DataGridView1.EditingControl, TextBox)
            Clipboard.SetDataObject(tb.SelectedText)
            tsslMain.Text = "クリップボードにコピーしました。"
        End If
    End Sub

    Private Sub コピーCToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles コピーCToolStripMenuItem1.Click
        コピーCToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub コピーCToolStripButton_Click(sender As Object, e As EventArgs) Handles コピーCToolStripButton.Click
        コピーCToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ヘッダ付きで出力HToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ヘッダ付きで出力HToolStripMenuItem.Click
        refreshWithHeader()
    End Sub

    Private Sub ヘッダ付きで出力HToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles ヘッダ付きで出力HToolStripMenuItem1.Click
        ヘッダ付きで出力HToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ヘッダ付きで出力HToolStripButton_Click(sender As Object, e As EventArgs) Handles ヘッダ付きで出力HToolStripButton.Click
        ヘッダ付きで出力HToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub バージョン情報AToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles バージョン情報AToolStripMenuItem.Click
        frmAbout.ShowDialog()
    End Sub

    Private Sub バージョン情報BToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles バージョン情報BToolStripMenuItem.Click
        バージョン情報AToolStripMenuItem_Click(sender, e)
    End Sub

    Private Sub ヘルプLToolStripButton_Click(sender As Object, e As EventArgs) Handles ヘルプLToolStripButton.Click
        バージョン情報AToolStripMenuItem_Click(sender, e)
    End Sub

    ' フォルダ参照ダイアログを開く
    Private Function BrowseFolder(ByRef path As String) As DialogResult
        BrowseFolder = FolderBrowserDialog1.ShowDialog
        If BrowseFolder = DialogResult.OK Then
            path = FolderBrowserDialog1.SelectedPath
        End If
    End Function

    ' ファイルを開き、画面に表示する
    Private Sub OpenFiles(path As String)
        Dim fs As System.IO.FileStream

        ' info.bdav
        Dim infoFile() As String ' ファイルパス
        Dim info(65536) As Byte ' ファイルの内容格納用

        Dim rplsFiles() As String ' ファイルパス
        Dim item(65536) As Byte ' ファイルの内容格納用

        Dim diskName As String ' ディスク名
        Dim row As DataGridViewRow ' 行オブジェクト

        Dim playlist_detail2_length As Integer ' 詳細2の長さ
        Dim j As Integer ' ループカウンタ
        Dim start As Integer ' 詳細2の開始位置

        On Error GoTo error_handler

        ' info.bdavの読み込み
        infoFile = GetInfoFile(path)
        diskName = ""
        If Not IsNothing(infoFile) AndAlso infoFile.Length > 0 Then
            fs = New System.IO.FileStream(infoFile(0), System.IO.FileMode.Open, System.IO.FileAccess.Read)
            fs.Read(info, 0, info.Length)
            fs.Close()
            diskName = decodeString(info, info(64), 65)
        End If

        ' rplsファイルの読み込み
        rplsFiles = GetRplsFiles(path)
        If IsNothing(rplsFiles) OrElse rplsFiles.Length = 0 Then
            tsslMain.Text = "rplsファイルが見つかりませんでした。"
            Exit Sub
        End If

        tbDiskName.Text = diskName
        DataGridView1.Rows.Clear()

        ' rplsファイルの処理
        For i As Integer = 0 To rplsFiles.Length - 1 Step 1
            fs = New System.IO.FileStream(rplsFiles(i), System.IO.FileMode.Open, System.IO.FileAccess.Read)
            fs.Read(item, 0, item.Length)
            fs.Close()

            ' 配列を拡張する
            ReDim Preserve playlists(i)

            ' No.
            playlists(i).number = Mid(rplsFiles(i), _
                                        rplsFiles(i).LastIndexOf("\") + 2, _
                                        rplsFiles(i).LastIndexOf(".") - rplsFiles(i).LastIndexOf("\") - 1)

            ' 録画日時
            playlists(i).record_date = item(50).ToString("X2") + _
                                        item(51).ToString("X2") + "/" + _
                                        item(52).ToString("X2") + "/" + _
                                        item(53).ToString("X2") + " " + _
                                        item(54).ToString("X2") + ":" + _
                                        item(55).ToString("X2") + ":" + _
                                        item(56).ToString("X2")

            ' 録画時間
            playlists(i).duration = item(57).ToString("X2") + ":" + _
                                    item(58).ToString("X2") + ":" + _
                                    item(59).ToString("X2")

            ' Ch.
            playlists(i).channel = (item(64) * 256 + item(65)).ToString

            ' 放送局名
            playlists(i).channel_name = decodeString(item, item(67), 68)

            ' 名称
            playlists(i).playlist_name = decodeString(item, item(88), 89)

            ' 詳細
            playlists(i).playlist_detail = decodeString(item, item(344) * 256 + item(345), 346)

            ' 詳細2
            start = 346 + item(344) * 256 + item(345)
            j = start
            While item(j) <> 0
                j += 1
            End While
            playlist_detail2_length = j - start
            playlists(i).playlist_detail2 = decodeString(item, playlist_detail2_length, start)

            ' メーカー
            playlists(i).maker_id = item(60) * 256 + item(61)

            ' 機種
            playlists(i).maker_model_code = item(62) * 256 + item(63)

            row = New DataGridViewRow
            row.CreateCells(DataGridView1)
            DataGridView1.Rows.Add(row)
            DataGridView1("numberColumn", i).Value = playlists(i).number
            DataGridView1("recordDateColumn", i).Value = playlists(i).record_date
            DataGridView1("durationColumn", i).Value = playlists(i).duration
            DataGridView1("channelColumn", i).Value = playlists(i).channel
            DataGridView1("channelNameColumn", i).Value = playlists(i).channel_name
            DataGridView1("nameColumn", i).Value = playlists(i).playlist_name
            DataGridView1("detailColumn", i).Value = playlists(i).playlist_detail
            DataGridView1("detailColumn2", i).Value = playlists(i).playlist_detail2
            DataGridView1("makerIDColumn", i).Value = playlists(i).maker_id
            DataGridView1("makerModelCodeColumn", i).Value = playlists(i).maker_model_code
        Next i
        上書き保存SToolStripMenuItem.Enabled = True
        上書き保存SToolStripButton.Enabled = True
        名前を付けて保存AToolStripMenuItem.Enabled = True
        コピーCToolStripMenuItem.Enabled = True
        コピーCToolStripButton.Enabled = True
        tsslMain.Text = "ファイルを読み込みました。"
        Exit Sub

error_handler:
        tsslMain.Text = "エラーが発生しました。 :" + Err.Description
    End Sub

    ' info.bdavファイルのパスを取得する
    Private Function GetInfoFile(path As String) As String()
        Dim files() As String
        Dim files_dummy(0) As String

        ' 指定されたフォルダを検索
        On Error Resume Next
        files = System.IO.Directory.GetFiles(path, "info.bdav", System.IO.SearchOption.TopDirectoryOnly)
        On Error GoTo 0

        ' 指定されたフォルダの下のBDAVフォルダを検索
        If IsNothing(files) OrElse files.Length = 0 Then
            On Error Resume Next
            files = System.IO.Directory.GetFiles(System.IO.Path.Combine(path, "BDAV"), "info.bdav", System.IO.SearchOption.TopDirectoryOnly)
            On Error GoTo 0
        End If

        ' ファイルが見つかった場合
        If Not IsNothing(files) AndAlso files.Length > 0 Then
            GetInfoFile = files
        End If
    End Function

    ' rplsファイルのパスを取得する
    Private Function GetRplsFiles(path As String) As String()
        Dim files() As String
        Dim files_dummy(0) As String

        ' 指定されたフォルダを検索
        On Error Resume Next
        files = System.IO.Directory.GetFiles(path, "*.rpls", System.IO.SearchOption.TopDirectoryOnly)
        On Error GoTo 0

        ' 指定されたフォルダの下のPLAYLISTフォルダを検索
        If IsNothing(files) OrElse files.Length = 0 Then
            On Error Resume Next
            files = System.IO.Directory.GetFiles(System.IO.Path.Combine(path, "PLAYLIST"), "*.rpls", System.IO.SearchOption.TopDirectoryOnly)
            On Error GoTo 0
        End If

        ' 指定されたフォルダの下のBDAV\PLAYLISTフォルダを検索
        If IsNothing(files) OrElse files.Length = 0 Then
            On Error Resume Next
            files = System.IO.Directory.GetFiles(System.IO.Path.Combine(System.IO.Path.Combine(path, "BDAV"), "PLAYLIST"), "*.rpls", System.IO.SearchOption.TopDirectoryOnly)
            On Error GoTo 0
        End If

        ' ファイルが見つからなかった場合
        If IsNothing(files) OrElse files.Length = 0 Then
            ' パスをファイル名とみなして検索
            If System.IO.File.Exists(path) Then
                files = files_dummy
                files(0) = path
                GetRplsFiles = files
            Else
                '
            End If
        Else
            GetRplsFiles = files
        End If
    End Function

    ' DataGridViewの内容をCSVファイルに保存する
    Private Sub SaveCSVFile(fileName As String)
        Dim sw As System.IO.StreamWriter
        sw = New System.IO.StreamWriter(fileName, False, System.Text.Encoding.Default)

        On Error GoTo error_handler

        ' バージョン 1.10 ヘッダ付きで出力オプションがTrueの場合、ヘッダを出力する
        If withHeader Then
            sw.WriteLine( _
                Chr(34) + DataGridView1.Columns("numberColumn").HeaderText + Chr(34) + "," + _
                Chr(34) + DataGridView1.Columns("recordDateColumn").HeaderText + Chr(34) + "," + _
                Chr(34) + DataGridView1.Columns("durationColumn").HeaderText + Chr(34) + "," + _
                Chr(34) + DataGridView1.Columns("channelColumn").HeaderText + Chr(34) + "," + _
                Chr(34) + DataGridView1.Columns("channelNameColumn").HeaderText + Chr(34) + "," + _
                Chr(34) + DataGridView1.Columns("nameColumn").HeaderText + Chr(34) + "," + _
                Chr(34) + DataGridView1.Columns("detailColumn").HeaderText + Chr(34) + "," + _
                Chr(34) + DataGridView1.Columns("detailColumn2").HeaderText + Chr(34) + "," + _
                Chr(34) + DataGridView1.Columns("makerIDColumn").HeaderText + Chr(34) + "," + _
                Chr(34) + DataGridView1.Columns("makerModelCodeColumn").HeaderText + Chr(34) _
            )
        End If

        ' バージョン 1.10 playlistsの値ではなくDataGridViewの値を保存するよう変更
        For i As Integer = 0 To DataGridView1.RowCount - 1 Step 1
            sw.WriteLine( _
                Chr(34) + DataGridView1.Rows(i).Cells("numberColumn").Value + Chr(34) + "," + _
                Chr(34) + DataGridView1.Rows(i).Cells("recordDateColumn").Value + Chr(34) + "," + _
                Chr(34) + DataGridView1.Rows(i).Cells("durationColumn").Value + Chr(34) + "," + _
                Chr(34) + DataGridView1.Rows(i).Cells("channelColumn").Value + Chr(34) + "," + _
                Chr(34) + DataGridView1.Rows(i).Cells("channelNameColumn").Value + Chr(34) + "," + _
                Chr(34) + DataGridView1.Rows(i).Cells("nameColumn").Value + Chr(34) + "," + _
                Chr(34) + DataGridView1.Rows(i).Cells("detailColumn").Value + Chr(34) + "," + _
                Chr(34) + DataGridView1.Rows(i).Cells("detailColumn2").Value + Chr(34) + "," + _
                Chr(34) + DataGridView1.Rows(i).Cells("makerIDColumn").Value + Chr(34) + "," + _
                Chr(34) + DataGridView1.Rows(i).Cells("makerModelCodeColumn").Value + Chr(34) _
            )
        Next i
        sw.Close()
        tsslMain.Text = "ファイルを保存しました。"
        Exit Sub

error_handler:
        tsslMain.Text = "エラーが発生しました。 :" + Err.Description
    End Sub

    ' ヘッダ付きで出力オプションの値を更新する
    Private Sub refreshWithHeader()
        If withHeader Then
            withHeader = False
        Else
            withHeader = True
        End If
        ヘッダ付きで出力HToolStripMenuItem.Checked = withHeader
        ヘッダ付きで出力HToolStripMenuItem1.Checked = withHeader
        ヘッダ付きで出力HToolStripButton.Checked = withHeader
    End Sub

End Class
